Codeforces Round #423 (Div. 2, rated, based on VK Cup Finals) C. String Reconstruction 并查集

C. String Reconstruction

题目连接:

http://codeforces.com/contest/828/problem/C

Description

Ivan had string s consisting of small English letters. However, his friend Julia decided to make fun of him and hid the string s. Ivan preferred making a new string to finding the old one.

Ivan knows some information about the string s. Namely, he remembers, that string ti occurs in string s at least ki times or more, he also remembers exactly ki positions where the string ti occurs in string s: these positions are xi, 1, xi, 2, ..., xi, ki. He remembers n such strings ti.

You are to reconstruct lexicographically minimal string s such that it fits all the information Ivan remembers. Strings ti and string s consist of small English letters only.

Input

The first line contains single integer n (1 ≤ n ≤ 105) — the number of strings Ivan remembers.

The next n lines contain information about the strings. The i-th of these lines contains non-empty string ti, then positive integer ki, which equal to the number of times the string ti occurs in string s, and then ki distinct positive integers xi, 1, xi, 2, ..., xi, ki in increasing order — positions, in which occurrences of the string ti in the string s start. It is guaranteed that the sum of lengths of strings ti doesn't exceed 106, 1 ≤ xi, j ≤ 106, 1 ≤ ki ≤ 106, and the sum of all ki doesn't exceed 106. The strings ti can coincide.

Output

Print lexicographically minimal string that fits all the information Ivan remembers.

Sample Input

3
a 4 1 3 5 7
ab 2 1 5
ca 1 4

Sample Output

abacaba

Hint

题意

给n个字符串,告诉你有n个位置的是这个字符串的开始,然后让你输出最后字符串的样子。

题解:

由于显然每个位置的字符是唯一的,换句话而言,就是每个位置我们都只用访问一次就够了,没必要重复的进行访问。

我们用并查集去维护这个就好了。

代码

#include<stdio.h>
#include<iostream>
#include<string.h>
using namespace std;
const int maxn = 2e6+7;
int fa[maxn];
int ans[maxn];
int fi(int x){
    return x==fa[x]?x:fa[x]=fi(fa[x]);
}
int n,mx=0;
string s;
int main(){
    scanf("%d",&n);
    for(int i=0;i<maxn;i++)fa[i]=i;
    int mx = 0;
    for(int i=0;i<n;i++){
        cin>>s;
        int k;
        scanf("%d",&k);
        for(int j=0;j<k;j++){
            int x;
            scanf("%d",&x);
            int st=x;
            int end=x+s.size();
            mx=max(mx,end);
            x=fi(x);
            while(x<end){
                ans[x]=s[x-st]-'a';
                int x2=fi(fi(x)+1);
                fa[fi(x)]=x2;
                x=x2;
            }
        }
    }
    for(int i=1;i<mx;i++)
        cout<<char(ans[i]+'a');
    cout<<endl;
}
posted @ 2017-07-16 11:02  qscqesze  阅读(365)  评论(0编辑  收藏  举报